#include <stdio.h>
#include <math.h>

FILE * plik;

const char * bridge_phases[][2] = {
							 { "A_P1","B_P2"},
							 { "A_P1","B_P1"},
							 { "A_P2","B_P1"},
							 { "A_P2","B_P2"}
};

const char * bridge_phases_val[][2] = {
							 { "0x80","0x00"},
							 { "0x80","0x40"},
							 { "0x00","0x40"},
							 { "0x00","0x00"}
};

const char  mixed_decay_phases[][2][40] = {
							 { "A_SLOW ","B_MIXED"},
							 { "A_MIXED","B_SLOW "},
							 { "A_SLOW ","B_MIXED"},
							 { "A_MIXED","B_SLOW "}
};

const char  mixed_decay_phases_val[][2][40] = {
							 { "0x20","0x00"},
							 { "0x00","0x10"},
							 { "0x20","0x00"},
							 { "0x00","0x10"}
};



int main(int argc, char* argv[])
{	
	int			kroki;
	int			ii,jj,kk;
	double		pi = 3.1415926535;
	double		angle;
	double		sin_val;
	int			sin_ad;
	char	*	cntr_option;


	printf("Podaj liczbe krokow: ");
	scanf("%d",&kroki);
	if( (kroki > 128) || (kroki< 2))
	{
		printf("Zla liczba krokw :%d (musi by 2..128)\n",kroki);
		return -1;
	}

		
	if( (plik= fopen( "rom_table_init.gen", "w" )) == NULL )
    {
	   printf( "Nie mona otworzy pliku 'rom_table_init.gen'\n");
	   return -1;
    }

	fprintf(plik,"#define STEP_NUMBER %d\n",kroki);

	fclose( plik );

	if( (plik= fopen( "rom_table_data.gen", "w" )) == NULL )
    {
	   printf( "Nie mona otworzy pliku 'rom_table_data.gen'\n");
	   return -1;
    }


	fprintf(plik,"rom_sinus_table_step:\n");

	for(ii = 0; ii < 2; ii++)
	{
		for(jj = 0; jj < kroki; jj++)
		{
			angle = (pi/2) * ii + (pi/2)* (double)jj / (double)kroki;	
			sin_val = sin(angle);
			sin_ad = abs((int)(((double)4095 * sin_val + 0.5)));

			fprintf(plik,".dw  0x%03x ; %d of %d (%+5.4f (%+5.2f deg)sinus value  %+5.2f volt )\n",
					sin_ad, 
					ii*kroki+jj,
					2*kroki,
					sin_val,
					angle * 180 / pi,
					4.095 * sin_val
			);
		}

		if(ii == 0)
		{
			fprintf(plik,"rom_sinus_table_step_half:\n");
		}

	
	}

	fprintf(plik,"rom_sinus_table_step_end:\n");


	fprintf(plik,"rom_decay_table:\n");

	for(ii =0; ii < 4; ii++)
	{
		for(jj = 0; jj < kroki; jj++)
		{
			
			kk = ii* kroki + jj;
		
			if( kk == 0) 
			{
				cntr_option     = "CH_A_MIN_MIN";
			}
			else if ( kk == 2* kroki) 
			{
				cntr_option     = "CH_A_MIN";
			}
			else if ( kk == (4* kroki -1))
			{
				cntr_option     = "CH_A_MAX_MAX";
			}
			else if ( kk == (2* kroki -1)) 
			{
				cntr_option     = "CH_A_MAX";
			}
			else if ( (kk == (3* kroki -1)) || (kk == (kroki -1)) )
			{
				cntr_option     = "CH_B_MAX";
			}
			else if ( (kk == (3* kroki)) || (kk == kroki) )
			{
				cntr_option     = "CH_B_MIN";
			}
			else
			{
				cntr_option = "CH_AB_NONE ";
			}

			fprintf(plik,".dw %s|%s|%s|%s|%s  ; (%s/%s/%s/%s) %d of %d \n",
					bridge_phases_val[ii][0],
					bridge_phases_val[ii][1],
					mixed_decay_phases_val[ii][0],
					mixed_decay_phases_val[ii][1],
					cntr_option,
					bridge_phases[ii][0],
					bridge_phases[ii][1],
					mixed_decay_phases[ii][0],
					mixed_decay_phases[ii][1],					
					ii*kroki + jj,
					4*kroki
					);
		}
	}

	fprintf(plik,"rom_decay_table_end:\n");



	fclose( plik );
      
	return 0;
}