;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; **************** D/A converter support  ***************************
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPI initialization for the converter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.macro SPI_INITIALIZE
	; Enable  as master with fosc/2, idle clock high
	ldi temp, _BV(SPE) | _BV(MSTR)  | _BV(CPOL)  | _BV(CPHA)
	out SPCR,temp
	ldi temp, _BV(SPI2X)   
	out SPSR,temp
.endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPI transfer to the D/A converter (uses predefined registers)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; Private macro
.macro SPI_WAIT
wait_tr:	
	in	 temp,SPSR
	sbrs temp,SPIF
	rjmp wait_tr
.endmacro


.macro SPI_TRANSFER

	; Transfer channel A	
	out SPDR,CH_A_SPI_H
	SPI_WAIT
	out SPDR,CH_A_SPI_L
	SPI_WAIT
	LOAD_CLR
	LOAD_SET

	; Transfer channel B
	out SPDR,CH_B_SPI_H
	SPI_WAIT
	out SPDR,CH_B_SPI_L
	SPI_WAIT
	LOAD_CLR
	LOAD_SET

.endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPI transfer to the D/A converter 
; Uses max. D/A values to get max. voltage on D/A output
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.macro SPI_TRANSFER_ADJUST
	; Transfer channel A	
	ldi temp,CH_A_SPI_H_FULL_STEP_CTRL	
	out SPDR,temp
	SPI_WAIT
	ldi temp,CH_A_SPI_L_FULL_STEP_CTRL	
	out SPDR,temp
	SPI_WAIT
	LOAD_CLR
	LOAD_SET

	; Transfer channel B
	ldi temp,CH_B_SPI_H_FULL_STEP_CTRL	
	out SPDR,temp
	SPI_WAIT
	ldi temp,CH_B_SPI_L_FULL_STEP_CTRL	
	out SPDR,temp
	SPI_WAIT
	LOAD_CLR
	LOAD_SET

.endmacro


